#include<bits/stdc++.h>
using namespace std;
long long a[300003],b[300003];
int main(){
	freopen("match.in","r",stdin);
	freopen("match.out","w",stdout);
	int T,n,m;
	cin>>T>>n;
	T=min(sqrt(n)+1,1.0*n);
	for(int i=1;i<=n;i++)
		scanf("%lld",&a[i]);
	for(int i=1;i<=n;i++)
		scanf("%lld",&b[i]);
	cin>>m;
	for(int i=1;i<=m;i++){
		int l,r;
		long long m1=0,m2=0;
		unsigned long long ans=0;
		scanf("%d%d",&l,&r);
		for(int j=l;j<=r;j++){
		m1=0;
		m2=0;
		for(int k=j;k<=r;k++){
			m1=max(m1,a[k]);
			m2=max(m2,b[k]);
			ans+=m1*m2;
		}
		}
	cout<<ans<<endl;
	}
}
